void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void JUDGE_1_init__(JUDGE_1 *data__, BOOL retain) {
  __INIT_LOCATED(BOOL,__IX0_0,data__->STATE1,retain)
  __INIT_LOCATED_VALUE(data__->STATE1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_1,data__->STATE2,retain)
  __INIT_LOCATED_VALUE(data__->STATE2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_2,data__->STATE3,retain)
  __INIT_LOCATED_VALUE(data__->STATE3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_0,data__->JUDGE1,retain)
  __INIT_LOCATED_VALUE(data__->JUDGE1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_1,data__->JUDGE2,retain)
  __INIT_LOCATED_VALUE(data__->JUDGE2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_2,data__->JUDGE3,retain)
  __INIT_LOCATED_VALUE(data__->JUDGE3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_3,data__->NOJUDGE,retain)
  __INIT_LOCATED_VALUE(data__->NOJUDGE,__BOOL_LITERAL(FALSE))
}

// Code part
void JUDGE_1_body__(JUDGE_1 *data__) {
  // Initialise TEMP variables

  __SET_LOCATED(data__->,JUDGE1,,((!(__GET_LOCATED(data__->STATE3,)) && !(__GET_LOCATED(data__->STATE2,))) && __GET_LOCATED(data__->STATE1,)));
  __SET_LOCATED(data__->,JUDGE2,,((!(__GET_LOCATED(data__->STATE3,)) && __GET_LOCATED(data__->STATE2,)) && !(__GET_LOCATED(data__->STATE1,))));
  __SET_LOCATED(data__->,JUDGE3,,((__GET_LOCATED(data__->STATE3,) && !(__GET_LOCATED(data__->STATE2,))) && !(__GET_LOCATED(data__->STATE1,))));
  __SET_LOCATED(data__->,NOJUDGE,,((!(__GET_LOCATED(data__->STATE3,)) && !(__GET_LOCATED(data__->STATE2,))) && !(__GET_LOCATED(data__->STATE1,))));

  goto __end;

__end:
  return;
} // JUDGE_1_body__() 





